OpenVDB: SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow Class Reference

OpenVDB 12.0.0 |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow Class Reference

Read-only accessor to a row of this matrix. More...

`#include <openvdb/math/ConjGradient.h>`

Inheritance diagram for SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow:

## Public Types
using | DataType

## Public Member Functions
| ConstRow (const ValueType *valueHead, const SizeType *columnHead, const SizeType &rowSize)
bool | empty () const
bool | empty () const
const SizeType & | size () const
const SizeType & | size () const
const ValueType & | getValue (SizeType columnIdx, bool &active) const
const ValueType & | getValue (SizeType columnIdx) const
const ValueType & | getValue (SizeType columnIdx, bool &active) const
const ValueType & | getValue (SizeType columnIdx) const
ConstValueIter | cbegin () const
| Return an iterator over the stored values in this row.
ConstValueIter | cbegin () const
| Return an iterator over the stored values in this row.
bool | eq (const RowBase< OtherDataType > &other, ValueType eps=Tolerance< ValueType >::value()) const
| Return `true` if this row is equivalent to the given row to within the specified tolerance.
bool | eq (const RowBase< OtherDataType > &other, ValueType eps=Tolerance< ValueType >::value()) const
| Return `true` if this row is equivalent to the given row to within the specified tolerance.
VecValueType | dot (const VecValueType *inVec, SizeType vecSize) const
| Return the dot product of this row with the first vecSize elements of inVec.
VecValueType | dot (const Vector< VecValueType > &inVec) const
| Return the dot product of this row with the given vector.
VecValueType | dot (const VecValueType *inVec, SizeType vecSize) const
| Return the dot product of this row with the first vecSize elements of inVec.
VecValueType | dot (const Vector< VecValueType > &inVec) const
| Return the dot product of this row with the given vector.
std::string | str () const
| Return a string representation of this row.
std::string | str () const
| Return a string representation of this row.

## Static Public Member Functions
static SizeType | capacity ()
static SizeType | capacity ()

## Protected Member Functions
const ValueType & | value (SizeType i) const
const ValueType & | value (SizeType i) const
SizeType | column (SizeType i) const
SizeType | column (SizeType i) const
SizeType | find (SizeType columnIdx) const
| Return the array index of the first column index that is equal to or greater than the given column index.
SizeType | find (SizeType columnIdx) const
| Return the array index of the first column index that is equal to or greater than the given column index.

## Protected Attributes
DataType | mData
DataType | mData

## Detailed Description

template<typename ValueType_, SizeType STENCIL_SIZE>
class openvdb::v12_0::math::pcg::SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow

Read-only accessor to a row of this matrix.

## Member Typedef Documentation

## ◆ DataType

using DataType
| inherited

## Constructor & Destructor Documentation

## ◆ ConstRow()

template<typename ValueType, SizeType STENCIL_SIZE>

ConstRow | ( | const ValueType * | valueHead,
|  | const SizeType * | columnHead,
|  | const SizeType & | rowSize )
| inline

## Member Function Documentation

## ◆ capacity() [1/2]

static SizeType capacity | ( |  | ) |
| inlinestaticinherited

## ◆ capacity() [2/2]

static SizeType capacity | ( |  | ) |
| inlinestaticinherited

## ◆ cbegin() [1/2]

ConstValueIter cbegin | ( |  | ) | const
| inherited

Return an iterator over the stored values in this row.

## ◆ cbegin() [2/2]

SparseStencilMatrix< ValueType, STENCIL_SIZE >::ConstValueIter cbegin | ( |  | ) | const
| inlineinherited

Return an iterator over the stored values in this row.

## ◆ column() [1/2]

SizeType column | ( | SizeType | i | ) | const
| inlineprotectedinherited

## ◆ column() [2/2]

SizeType column | ( | SizeType | i | ) | const
| inlineprotectedinherited

## ◆ dot() [1/4]

VecValueType dot | ( | const Vector< VecValueType > & | inVec | ) | const
| inherited

Return the dot product of this row with the given vector.

## ◆ dot() [2/4]

VecValueType dot | ( | const Vector< VecValueType > & | inVec | ) | const
| inlineinherited

Return the dot product of this row with the given vector.

## ◆ dot() [3/4]

VecValueType dot | ( | const VecValueType * | inVec,
|  | SizeType | vecSize ) const
| inherited

Return the dot product of this row with the first vecSize elements of inVec.

Warning
  inVec must have at least vecSize elements.

## ◆ dot() [4/4]

VecValueType dot | ( | const VecValueType * | inVec,
|  | SizeType | vecSize ) const
| inlineinherited

Return the dot product of this row with the first vecSize elements of inVec.

Warning
  inVec must have at least vecSize elements.

## ◆ empty() [1/2]

bool empty | ( |  | ) | const
| inlineinherited

## ◆ empty() [2/2]

bool empty | ( |  | ) | const
| inlineinherited

## ◆ eq() [1/2]

bool eq | ( | const RowBase< OtherDataType > & | other,
|  | ValueType | eps = Tolerance<ValueType>::value() ) const
| inherited

Return `true` if this row is equivalent to the given row to within the specified tolerance.

## ◆ eq() [2/2]

bool eq | ( | const RowBase< OtherDataType > & | other,
|  | ValueType | eps = Tolerance<ValueType>::value() ) const
| inlineinherited

Return `true` if this row is equivalent to the given row to within the specified tolerance.

## ◆ find() [1/2]

SizeType find | ( | SizeType | columnIdx | ) | const
| protectedinherited

Return the array index of the first column index that is equal to or greater than the given column index.

Note
  If columnIdx is larger than any existing column index, the return value will point beyond the end of the array.

## ◆ find() [2/2]

SizeType find | ( | SizeType | columnIdx | ) | const
| inlineprotectedinherited

Return the array index of the first column index that is equal to or greater than the given column index.

Note
  If columnIdx is larger than any existing column index, the return value will point beyond the end of the array.

## ◆ getValue() [1/4]

const ValueType & getValue | ( | SizeType | columnIdx | ) | const
| inherited

## ◆ getValue() [2/4]

const ValueType & getValue | ( | SizeType | columnIdx | ) | const
| inlineinherited

## ◆ getValue() [3/4]

const ValueType & getValue | ( | SizeType | columnIdx,
|  | bool & | active ) const
| inherited

## ◆ getValue() [4/4]

const ValueType & getValue | ( | SizeType | columnIdx,
|  | bool & | active ) const
| inlineinherited

## ◆ size() [1/2]

const SizeType & size | ( |  | ) | const
| inlineinherited

## ◆ size() [2/2]

const SizeType & size | ( |  | ) | const
| inlineinherited

## ◆ str() [1/2]

std::string str | ( |  | ) | const
| inherited

Return a string representation of this row.

## ◆ str() [2/2]

std::string str | ( |  | ) | const
| inlineinherited

Return a string representation of this row.

## ◆ value() [1/2]

const ValueType & value | ( | SizeType | i | ) | const
| inlineprotectedinherited

## ◆ value() [2/2]

const ValueType & value | ( | SizeType | i | ) | const
| inlineprotectedinherited

## Member Data Documentation

## ◆ mData [1/2]

DataType mData
| protectedinherited

## ◆ mData [2/2]

DataType mData
| protectedinherited